- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# CFB_ModePolicy Class Reference

Inheritance diagram for CFB_ModePolicy:

List of all members.

## Detailed Description

Definition at line 77 of file modes.h.

## Public Types
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
## Public Member Functions
IV_Requirement | IVRequirement () const
| returns the minimal requirement for secure IVs
size_t | MinKeyLength () const
| returns smallest valid key length in bytes */
size_t | MaxKeyLength () const
| returns largest valid key length in bytes */
size_t | DefaultKeyLength () const
| returns default (recommended) key length in bytes */
size_t | GetValidKeyLength (size_t n) const
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
bool | IsValidKeyLength (size_t n) const
| returns whether n is a valid key length
unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
unsigned int | IVSize () const
| returns size of IVs used by this object
StreamTransformation & | Ref ()
| return a reference to this object,
virtual unsigned int | MandatoryBlockSize () const
| returns block size, if input must be processed in blocks, otherwise 1
virtual unsigned int | OptimalBlockSize () const
| returns the input block size that is most efficient for this cipher
virtual unsigned int | GetOptimalBlockSizeUsed () const
| returns how much of the current block is used up
virtual void | ProcessData (byte *outString, const byte *inString, size_t length)=0
| encrypt or decrypt an array of bytes of specified length
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| for ciphers where the last block of data is special, encrypt or decrypt the last block of data
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| same as ProcessData(inoutString, inoutString, length)
void | ProcessString (byte *outString, const byte *inString, size_t length)
| same as ProcessData(outString, inString, length)
byte | ProcessByte (byte input)
| implemented as {ProcessData(&input, &input, 1); return input;}
virtual bool | IsRandomAccess () const=0
| returns whether this cipher supports random access
virtual void | Seek (lword n)
| for random access ciphers, seek to an absolute position
virtual bool | IsSelfInverting () const=0
| returns whether this transformation is self-inverting (e.g. xor with a keystream)
virtual bool | IsForwardTransformation () const=0
| returns whether this is an encryption object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| set or reset the key of this object
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors)
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
virtual void | Resynchronize (const byte *IV)
| resynchronize with an IV
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *IV)
| get a secure IV for the next message
virtual bool | CanIterate () const
virtual void | Iterate (byte *output, const byte *input, CipherDir dir, size_t iterationCount)
## Static Public Member Functions
static const char *__cdecl | StaticAlgorithmName ()
## Protected Member Functions
unsigned int | GetBytesPerIteration () const
byte * | GetRegisterBegin ()
void | TransformRegister ()
void | CipherResynchronize (const byte *iv)
void | SetFeedbackSize (unsigned int feedbackSize)
void | ResizeBuffers ()
unsigned int | BlockSize () const
virtual const Algorithm & | GetAlgorithm () const=0
virtual void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)=0
void | ThrowIfInvalidKeyLength (size_t length)
void | ThrowIfResynchronizable ()
void | ThrowIfInvalidIV (const byte *iv)
const byte * | GetIVAndThrowIfInvalid (const NameValuePairs &params)
void | AssertValidKeyLength (size_t length) const
## Protected Attributes
SecByteBlock | m_temp
unsigned int | m_feedbackSize
BlockCipher * | m_cipher
SecByteBlock | m_register

## Member Enumeration Documentation

enum SimpleKeyingInterface::IV_Requirement`[inherited]`

Enumerator:

  UNIQUE_IV |
  RANDOM_IV |
  UNPREDICTABLE_RANDOM_IV |
  INTERNALLY_GENERATED_IV |
  NOT_RESYNCHRONIZABLE |

Definition at line 382 of file cryptlib.h.

## Member Function Documentation

StreamTransformation& StreamTransformation::Ref | ( |  | ) | `[inline, inherited]`

return a reference to this object,

This function is useful for passing a temporary StreamTransformation object to a function that takes a non-const reference.

Definition at line 470 of file cryptlib.h.

virtual unsigned int StreamTransformation::OptimalBlockSize | ( |  | ) | const`[inline, virtual, inherited]`

returns the input block size that is most efficient for this cipher

Note:
  optimal input length is n * OptimalBlockSize() - GetOptimalBlockSizeUsed() for any n > 0

Reimplemented in ECB_OneWay.

Definition at line 477 of file cryptlib.h.

Referenced by StreamTransformationFilter::FirstPut().

virtual void StreamTransformation::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length |
| ) |  |  | `[pure virtual, inherited]`

encrypt or decrypt an array of bytes of specified length

Note:
  either inString == outString, or they don't overlap

Implemented in Weak1::ARC4_Base, PublicBlumBlumShub, and BlockOrientedCipherModeBase.

Referenced by StreamTransformationFilter::LastPut(), and StreamTransformation::ProcessLastBlock().

void StreamTransformation::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length |
| ) |  |  | `[virtual, inherited]`

for ciphers where the last block of data is special, encrypt or decrypt the last block of data

For now the only use of this function is for CBC-CTS mode.

Reimplemented in CBC_CTS_Encryption, and CBC_CTS_Decryption.

Definition at line 119 of file cryptlib.cpp.

References StreamTransformation::MandatoryBlockSize(), StreamTransformation::MinLastBlockSize(), and StreamTransformation::ProcessData().

Referenced by StreamTransformationFilter::LastPut().

void SimpleKeyingInterface::SetKey | ( | const byte * | key,
|  | size_t | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs` |
| ) |  |  | `[virtual, inherited]`

set or reset the key of this object

Parameters:

  | params | is used to specify Rounds, BlockSize, etc

Reimplemented in ECB_OneWay.

Definition at line 52 of file cryptlib.cpp.

References SimpleKeyingInterface::ThrowIfInvalidKeyLength().

Referenced by CBC_MAC< T >::CBC_MAC(), CipherModeFinalTemplate_CipherHolder< CIPHER, BASE >::CipherModeFinalTemplate_CipherHolder(), DMAC< T >::DMAC(), HMAC< T >::HMAC(), Weak::PanamaMAC< B >::PanamaMAC(), ECB_OneWay::SetKey(), SimpleKeyingInterface::SetKeyWithIV(), SimpleKeyingInterface::SetKeyWithRounds(), VMAC_Base::UncheckedSetKey(), and BlockOrientedCipherModeBase::UncheckedSetKey().

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const`[inline, inherited]`

returns whether this object can be resynchronized (i.e. supports initialization vectors)

If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed.

Definition at line 388 of file cryptlib.h.

Referenced by SimpleKeyingInterface::ThrowIfInvalidIV(), SimpleKeyingInterface::ThrowIfResynchronizable(), and BlockOrientedCipherModeBase::UncheckedSetKey().

void SimpleKeyingInterface::GetNextIV | ( | RandomNumberGenerator & | rng,
|  | byte * | IV |
| ) |  |  | `[virtual, inherited]`

get a secure IV for the next message

This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects.

Reimplemented in VMAC_Base.

Definition at line 96 of file cryptlib.cpp.

References RandomNumberGenerator::GenerateBlock(), and SimpleKeyingInterface::IVSize().

Referenced by VMAC_Base::GetNextIV().

The documentation for this class was generated from the following file:

- modes.h